/* --------------------------------------------------------------------------------- */
/* Пример example-g03n04.c                                                           */
/* --------------------------------------------------------------------------------- */
 #include <stdio.h>
 #include <libakrypt.h>

 int main( void )
{
  size_t i = 0;
 /* контекст секретного ключа */
  struct hmac ctx;
 /* массив данных для зашифрования длины 313 байт (19*16 + 9 = 6*48 + 25) */
  ak_uint8 data[215];
 /* массив, в который будет помещаться вычисленное значение */
  ak_uint8 im[64];
 /* константное значение ключа */
  ak_uint8 key[32] = {
    0xef, 0xcd, 0xab, 0x89, 0x67, 0x45, 0x27, 0x01,
    0x10, 0x32, 0x54, 0x76, 0x98, 0xba, 0xdc, 0xfe,
    0x77, 0x66, 0x55, 0x44, 0x33, 0x22, 0x11, 0x00,
    0xff, 0xee, 0xdd, 0xcc, 0xbb, 0xaa, 0x99, 0x38  };


 /* инициализируем криптобиблиотеку
    и явно указываем функцию вывода сообщений аудита */
  if( ak_libakrypt_create( NULL ) != ak_true ) {
    ak_libakrypt_destroy();
    return EXIT_FAILURE;
  }
 /* формируем данные, для которых будет вырабатываться имитовставка */
  for( i = 0; i < sizeof( data ); i++ ) data[i] = (ak_uint8)i+1;

 /* создаем ключ алгоритма, использующего функцию Стрибог256,
    после чего, присваиваем ему константное значение */
  ak_hmac_create_streebog256( &ctx );
  ak_hmac_set_key( &ctx, key, 32 );

 /* вычисляем значение имитовставки
    при использовании функции Стрибог256 длина вырабатываемой
    имитовставки равняется 32. */
  ak_hmac_ptr( &ctx, data, sizeof( data ), im, 32 );

 /* выводим вычисленное значение */
  printf("im: %s\n", ak_ptr_to_hexstr( im, 32, ak_false ));
 /* выводим ожидаемое значение */
  printf("im: 5de264565f302fed8866cb4d0b46ab6294d087bcd66779e9bd3b3eb96fa9beac (expected)\n");
 /* освобождаем контекст секретного ключа и контекст генератора */
  ak_hmac_destroy( &ctx );
  ak_libakrypt_destroy();

 return EXIT_SUCCESS;
}
